/*
 * Atz_XML_SAX_DataHandler.cpp
 *
 * Paul J. Atzberger
 * http://atzberger.org/
 *
 */

#include "Atz_XML_Handler_Example_A.h"
#include "SELM_Package.h"

using namespace std;
using namespace LAMMPS_NS;

Atz_XML_Handler_Example_A::Atz_XML_Handler_Example_A() {
  DataHandlerName = "Example_A";
  DataHandlerType = "Atz_XML_Handler_Example_A";
}

Atz_XML_Handler_Example_A::~Atz_XML_Handler_Example_A() {
  // TODO Auto-generated destructor stub
}

void Atz_XML_Handler_Example_A::XML_startDocument(Atz_XML_SAX_DataHandler* sourceHandler) {

}

void Atz_XML_Handler_Example_A::XML_endDocument(Atz_XML_SAX_DataHandler* sourceHandler) {
}

void Atz_XML_Handler_Example_A::XML_startElement(string qName, Atz_XML::AttributesType *attributes, Atz_XML_SAX_DataHandler* sourceHandler) {

  Atz_XML_SAX_Handler_Multilevel*    sourceHandler_Multilevel;
  Atz_XML_SAX_Handler_PrintToScreen* dataHandler_PrintToScreen;
  Atz_XML_Helper_DataHandler_List*   dataHandler_List;
  Atz_XML_SAX_DataHandler*           dataHandler;

  //checkCompatible(sourceHandler);
  //cout << "WARNING: Atz_XML_Handler_Example_A : XML_startElement()" << endl;
  //cout << "sourceHandler: type_id = " << typeid(sourceHandler).name() << endl;

  sourceHandler_Multilevel = dynamic_cast<Atz_XML_SAX_Handler_Multilevel*>(sourceHandler);
  //cout << "sourceHandler_Multilevel: type_id = " << typeid(sourceHandler_Multilevel).name() << endl;

  if (qName == "model") {
    //dataHandler_PrintToScreen = new Atz_XML_SAX_Handler_PrintToScreen();
    //sourceHandler_Multilevel->parseCurrentScopeWithDataHandler(dataHandler_PrintToScreen);
  } else if (qName == "childrenList") {
    dataHandler_List = new Atz_XML_Helper_DataHandler_List(new Atz_XML_SAX_Handler_PrintToScreen());
    sourceHandler_Multilevel->parseCurrentScopeWithDataHandler(dataHandler_List);
  } else { /* unrecognized tag then skip */
    dataHandler = new Atz_XML_Helper_Handler_SkipNextTag();
    sourceHandler_Multilevel->parseNextTagWithDataHandler(dataHandler);
  }

}

void Atz_XML_Handler_Example_A::XML_characters(string xmlString, Atz_XML_SAX_DataHandler* sourceHandler) {
}

void Atz_XML_Handler_Example_A::XML_endElement(string qName, Atz_XML_SAX_DataHandler* sourceHandler) {

  typedef Atz_XML_Helper_DataHandler_List::DataListMapType DataListMapType;
  typedef Atz_XML_Helper_DataHandler_List::ObjListType     ObjListType;

  Atz_XML_SAX_Handler_Multilevel*  sourceHandler_Multilevel;
  Atz_XML_Helper_DataHandler_List* dataHandler_List;
  DataListMapType::iterator        dataIterator;
  ObjListType                     *dataList;
  ObjListType::iterator            dataListIterator;
  string                          *childValue;

  sourceHandler_Multilevel = dynamic_cast<Atz_XML_SAX_Handler_Multilevel*>(sourceHandler);

  if (qName == "childrenList") {

    dataHandler_List = dynamic_cast<Atz_XML_Helper_DataHandler_List*>(sourceHandler_Multilevel->getLastUsedDataHandler());

    dataIterator     = dataHandler_List->getTagDataLists()->find("child");
    dataList         = dataIterator->second; /* list of names */

    /* display the list data */
    cout << "childrenList:" << endl;
    for (int k = 0; k < dataList->size(); k++) {
      childValue = (string *)(*dataList)[k];
      //childValue = (string *)dataList->at(k);
      cout << *childValue << endl;
    }

  }

}

void *Atz_XML_Handler_Example_A::XML_getData() { /* gets data from parsing the XML */
}


void Atz_XML_Handler_Example_A::checkCompatible(Atz_XML_SAX_DataHandler* dataHandler) {
  const char *error_str_code = "Atz_XML_Handler_Example_A.cpp";
  const char *error_str_func = "checkCompatible()";

  if (dataHandler->DataHandlerType != "Atz_XML_SAX_Handler_Multilevel") {
    stringstream message;
    message << "Data handler is not compatible" << endl;
    message << "DataHandlerType = " << dataHandler->DataHandlerType << endl;
    message << "type_id = " << typeid(dataHandler).name() << endl;
    SELM_Package::packageError(error_str_code, error_str_func, message);
  }

}
