/*
 * Atz_XML_SAX_DataHandler.h
 *
 * Paul J. Atzberger
 * http://atzberger.org/
 *
 */

#ifndef ATZ_XML_HANDLER_EXAMPLE_A_H_
#define ATZ_XML_HANDLER_EXAMPLE_A_H_

#include "mpi.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <map>
#include <typeinfo>

#include "SELM_Package.h"
#include "Atz_XML_Package.h"


using namespace std; /* ensures standard template library in namespace */

class Atz_XML_Handler_Example_A : public Atz_XML_SAX_DataHandler {

  public:
  Atz_XML_Handler_Example_A();
  virtual ~Atz_XML_Handler_Example_A();

  public:
    void XML_startDocument(Atz_XML_SAX_DataHandler* sourceHandler);

    void XML_endDocument(Atz_XML_SAX_DataHandler* sourceHandler);

    void XML_startElement(string qName, Atz_XML::AttributesType *attributes, Atz_XML_SAX_DataHandler* sourceHandler);

    void XML_characters(string xmlString, Atz_XML_SAX_DataHandler* sourceHandler);

    void XML_endElement(string qName, Atz_XML_SAX_DataHandler* sourceHandler);

    void *XML_getData(); /* gets data from parsing the XML */

    void checkCompatible(Atz_XML_SAX_DataHandler* dataHandler);

};

#endif /* ATZ_XML_HANDLER_EXAMPLE_A_H_ */
