/*
 * SELM_Eulerian_StaggeredGrid1_XML_Handler.h
 *
 * http://atzberger.org/
 *
 */

#ifndef SELM_EULERIAN_STAGGEREDGRID1_XML_HANDLER_H_
#define SELM_EULERIAN_STAGGEREDGRID1_XML_HANDLER_H_

#include "Atz_XML_Package.h"
#include "SELM_Eulerian_StaggeredGrid1.h"
#include "SELM_Eulerian_Delegator_XML_Handler.h"


namespace LAMMPS_NS {

class SELM_Eulerian_Delegator_XML_Handler; /* declare forward reference of class, since this
                                              also refers to the current class below */

class SELM_Eulerian_StaggeredGrid1_XML_Handler: public Atz_XML_SAX_DataHandler {
public:
	SELM_Eulerian_StaggeredGrid1_XML_Handler();
	SELM_Eulerian_StaggeredGrid1_XML_Handler(SELM_Eulerian_Delegator_XML_Handler *delegatorHandler);
	virtual ~SELM_Eulerian_StaggeredGrid1_XML_Handler();

	  string         xmlTagName_xml;
	  string         xmlTagName_SELM_Eulerian;
	  string         xmlTagName_EulerianName;
	  string         xmlTagName_num_dim;
	  string         xmlTagName_numMeshPtsPerDir;
	  string         xmlTagName_meshDeltaX;
	  string         xmlTagName_meshCenterX0;

	  string         xmlTagName_flagWriteSimulationData;
	  string         xmlTagName_saveSkipSimulationData;

	  string         xmlTagName_flagWriteFluidVel_VTK;
	  string         xmlTagName_flagWriteFluidForce_VTK;
	  string         xmlTagName_flagWriteFluidPressure_VTK;

	  friend class SELM_Eulerian_StaggeredGrid1;

	  SELM_Eulerian_StaggeredGrid1 *eulerian; /* object to construct */

	  Atz_XML::AttributesType *xmlAttributes;
	  string xmlString;

	 public:
	   void setupDataHandler();

	   void XML_startDocument(Atz_XML_SAX_DataHandler* sourceHandler);

	   void XML_endDocument(Atz_XML_SAX_DataHandler* sourceHandler);

	   void XML_startElement(string qName, Atz_XML::AttributesType *attributes, Atz_XML_SAX_DataHandler* sourceHandler);

	   void XML_characters(string xmlString, Atz_XML_SAX_DataHandler* sourceHandler);

	   void XML_endElement(string qName, Atz_XML_SAX_DataHandler* sourceHandler);

	   void *XML_getData(); /* gets data from parsing the XML */

};

}

#endif /* SELM_EULERIAN_STAGGEREDGRID1_XML_HANDLER_H_ */
