/*
 * SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler.cpp
 *
 * http://atzberger.org/
 *
 */

#include "SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
namespace LAMMPS_NS {
const char* SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::error_str_code = "SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler";

SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler() {
  setupDataHandler();
}

SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler(SELM_Integrator_Delegator_XML_Handler *delegatorHandler) {

  setupDataHandler();

  integrator = new SELM_Integrator_Forward_Euler_Period_Lag();

  strcpy(integrator->nameStr, delegatorHandler->SELM_IntegratorName);
  strcpy(integrator->typeStr, delegatorHandler->SELM_IntegratorTypeStr);

}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::setupDataHandler() {

  DataHandlerName                         = "Default Data Handler";
  DataHandlerType                         = "SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler";

  xmlTagName_xml                          = "xml";
  xmlTagName_SELM_Integrator              = "SELM_Integrator";
  xmlTagName_IntegratorName               = "IntegratorName";
  xmlTagName_maxTimeStepIndex             = "maxTimeStepIndex";
  xmlTagName_lagNumberTimeSteps           = "lagNumberTimeSteps";
  xmlTagName_deltaT                       = "deltaT";
  xmlTagName_mu                           = "mu";
  xmlTagName_rho                          = "rho";
  xmlTagName_KB                           = "KB";
  xmlTagName_T                            = "T";
  //xmlTagName_flagShearModeStr             = "flagShearModeStr";
/*
  xmlTagName_shearData                    = "shearData";

  //xmlTagName_RM_SHEAR1                    = "RM_SHEAR1";
  xmlTagName_shearRate                    = "shearRate";
  xmlTagName_shearDir                     = "shearDir";
  xmlTagName_shearVelDir                  = "shearVelDir";
  xmlTagName_shearDist                    = "shearDist";

  //xmlTagName_RM_OSC1                      = "RM_OSC1";
  xmlTagName_shearOmega                   = "shearOmega";
  xmlTagName_shearRateAmplitude           = "shearRateAmplitude";
*/
  xmlTagName_flagStochasticDriving        = "flagStochasticDriving";
  xmlTagName_flagIncompressibleFluid      = "flagIncompressibleFluid";
  xmlTagName_flagWriteSimulationData      = "flagWriteSimulationData";
  xmlTagName_saveSkipSimulationData       = "saveSkipSimulationData";

  integrator = NULL;

  parseMode  = PARSE_MODE_DEFAULT;

}

SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::~SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler() {

}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_startDocument(Atz_XML_SAX_DataHandler* sourceHandler) {

}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_endDocument(Atz_XML_SAX_DataHandler* sourceHandler) {

}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_startElement(
		string qName, Atz_XML::AttributesType *attributes, Atz_XML_SAX_DataHandler* sourceHandler) {

  const char *error_str_func = "XML_startElement()";

  SELM_Integrator_Forward_Euler_Period_Lag *integratorData;

  xmlAttributes = attributes;

  xmlString.clear();

  if (integrator != NULL) {
    integratorData = integrator;
  }

  if (qName == xmlTagName_xml) {

  } else if (qName == xmlTagName_SELM_Integrator) {

    /* setup the data structure */
    integrator = new SELM_Integrator_Forward_Euler_Period_Lag();

  } else if (qName == xmlTagName_IntegratorName) {

  } else if (qName == xmlTagName_maxTimeStepIndex) {

  } else if (qName == xmlTagName_lagNumberTimeSteps) {

  } else if (qName == xmlTagName_deltaT) {

  } else if (qName == xmlTagName_mu) {

  } else if (qName == xmlTagName_rho) {

  } else if (qName == xmlTagName_KB) {

  } else if (qName == xmlTagName_T) {

  } else if (qName == xmlTagName_flagStochasticDriving) {

  } else if (qName == xmlTagName_flagIncompressibleFluid) {

  } else if (qName == xmlTagName_flagWriteSimulationData) {

  } else if (qName == xmlTagName_saveSkipSimulationData) {

  } else { /* unrecognized tags skip (avoid sub-tags triggering something here) */
    Atz_XML_SAX_Handler_Multilevel*    sourceHandler_Multilevel;
    Atz_XML_SAX_DataHandler*           dataHandler;

    sourceHandler_Multilevel = dynamic_cast<Atz_XML_SAX_Handler_Multilevel*>(sourceHandler);
    dataHandler              = new Atz_XML_Helper_Handler_SkipNextTag();
    sourceHandler_Multilevel->parseNextTagWithDataHandler(dataHandler);
  }

}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_characters(string xmlString_in, Atz_XML_SAX_DataHandler* sourceHandler) {
  xmlString += xmlString_in;
}

void SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_endElement(string qName, Atz_XML_SAX_DataHandler* sourceHandler) {

  const char *error_str_func = "XML_endElement()";

  SELM_Integrator_Forward_Euler_Period_Lag* integratorData;

  if (integrator != NULL) {
    integratorData = integrator;
  }

  if (qName == xmlTagName_IntegratorName) {
      //strcpy(integrator->nameStr, Atz_XML_Helper_ParseData::getStringFromAttr(xmlAttributes)->c_str());
  } else if (qName == xmlTagName_maxTimeStepIndex) {
      integratorData->maxTimeStepIndex = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_lagNumberTimeSteps) {
      integratorData->lagNumberTimeSteps = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_deltaT) {
      integratorData->deltaT = Atz_XML_Helper_ParseData::getDoubleFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_mu) {
      integratorData->mu = Atz_XML_Helper_ParseData::getDoubleFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_rho) {
     integratorData->rho = Atz_XML_Helper_ParseData::getDoubleFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_KB) {
      integratorData->KB = Atz_XML_Helper_ParseData::getDoubleFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_T) {
      integratorData->T = Atz_XML_Helper_ParseData::getDoubleFromAttr(xmlAttributes);
    //} else if (qName == xmlTagName_flagShearModeStr) {

  } else if (qName == xmlTagName_flagStochasticDriving) {
      integratorData->flagStochasticDriving = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_flagIncompressibleFluid) {
      integratorData->flagIncompressibleFluid = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_flagWriteSimulationData) {
      integrator->flagWriteSimulationData = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else if (qName == xmlTagName_saveSkipSimulationData) {
      integrator->saveSkipSimulationData = Atz_XML_Helper_ParseData::getIntFromAttr(xmlAttributes);
  } else { /* unrecognized tags skip (avoid sub-tags triggering something here) */

  }
}

void *SELM_Integrator_Forward_Euler_Period_Lag_XML_Handler::XML_getData() { /* gets data from parsing the XML */
  return integrator;
}


}
