#!/bin/sh 

OUT_DIR="$PWD/output/run_lammps_direct/test_000"
MODEL_DIR="$PWD/Model1"

rm -ri $OUT_DIR
#rm -rf $OUT_DIR

mkdir -p $OUT_DIR
mkdir -p $OUT_DIR/vtk

cp -r $MODEL_DIR/* $OUT_DIR

echo ""
echo "Setting up symbolic links"
echo $PWD

# May need to adjust these next few lines for your system
# make more portable or put in path 
ln -s $PWD/lmp_atz_lammps_selm $OUT_DIR/lmp_atz_lammps_selm
ln -s $PWD/liblammps.so $OUT_DIR/liblammps.so
ln -s $PWD/liblammps_serial_debug_atz2.so $OUT_DIR/liblammps_serial_debug_atz2.so

echo ""
echo "Changing to output directory to run simulations."
cd $OUT_DIR

echo ""
echo "List files:"
ls -lah 

echo ""
echo "Run the simulation:"
LD_LIBRARY_PATH=$LD_LIBRARY_PATH:./

./lmp_atz_lammps_selm -in ./script/ex1.LAMMPS_script

